#include <stdio.h>
#include <stdlib.h>
#include <i86.h>
#include <conio.h>
#include "pmidi32.h"

#define BIOSseg 0x40

unsigned short *HEADptr = ((BIOSseg << 4) + 0x1a);
unsigned short *TAILptr = ((BIOSseg << 4) + 0x1c);
#define HEAD (*HEADptr)
#define TAIL (*TAILptr)
#define bios_kbhit() (HEAD - TAIL)

void _VideoPrint( char *s, int r, int c )
{
    volatile char *ptr = (char*)(0xb8000 + 160 * r + c*2);
    volatile int i = 0;

    while ( s[i] ) {
        *ptr++ = s[i++];
        *ptr++ = 0x3f;
    }
}

void DoExit( void )
{
	ShutDownMIDI();
}

main( int argc, char **argv )
{
    volatile int quit = 0, i = 0, o = 0;
    char buf[50];

	if ( argc < 2 ) {
		printf("usage: pmidi file.mid.\n");
		return 0;
	}
    atexit(DoExit);

    if ( LoadMIDIFile( argv[1] ) == 0 ) {
        printf("Error: Load midi file %s failed.\n", argv[1] );
        exit(-2);
	}

    printf("MIDI file loaded.\n");

	if ( PowerUpMIDI() == -1 ) {
		printf("Error: MIDI power up failed.\n");
        exit(-1);
	}

	PlayMIDI();

    printf("MIDI playing, press ESC to stop.\n");

    while( !quit && MIDIPlaying ) {
        for( i = 0; i < 2500; i ++ ) {
            if ( bios_kbhit()) {
                _disable();
                if ( getch() == 27 ) quit = 1;
                _enable();
            }
        }
        if ( o < MIDICallBackCount ) {
            o ++;
            sprintf( buf, "%d  ", o );
            _VideoPrint( buf, 15, 0 );
        }
	}

    return 0;
}
