#ifndef _PMIDI_H_
#define _PMIDI_H_

// The following definitions have effects only at compile time.
// You know that already don't you. :)

#define MAXTRACKS       32
#define FILE_UNK        0
#define FILE_MIDI       1
#define MAX_CALLBACKS   300
#define MIDI_TIMER      250
#define MIDI_VERBOSE_MODE  0   /* Prints out some messages */

#include "type32.h"


;   /*\
;---|*| public prototypes
;   \*/

    // Midi playing interface

	PUBLIC int  PASCAL PowerUpMIDI            ( void );
	PUBLIC void PASCAL ShutDownMIDI			  ( void );
	PUBLIC int  PASCAL PlayMIDI               ( void );
    PUBLIC int  PASCAL StopMIDI               ( void );
	PUBLIC int  PASCAL LoadMIDIFile           ( char *MIDFileName );


    // Protected mode interface to the services provided by the driver.

    PUBLIC i32  PASCAL msDeviceCheck( i16, i32 );
    PUBLIC int  PASCAL msGlobalReset( void );
    PUBLIC int  PASCAL msMIDImsg( char *, i16 );
    PUBLIC void PASCAL msPollMIDI( i16 );
    PUBLIC int  PASCAL msPreLoadPatch( i16, i16, void *, i32 );
    PUBLIC int  PASCAL msUnloadPatch( i16, i16 );
    PUBLIC int  PASCAL msGetLastError( void );

;   /*\
;---|*| PUBLIC Global variables
;   \*/

    // tells the midiplayer which tracks to play.
    // if all are true (non zero), then all tracks will be played.

    EXTERN char DoTracks[16];

    /* This is a read-only variable
     * Changing it won't affect the MIDI playing and playing driver
     * but your own codes */
	EXTERN int MIDIPlaying;

    // This is for reference, it doesn't have any effect on the player

    EXTERN _VOLATILE_ int  MIDICallBackCount;

#endif
